@echo off
setlocal
color 0C
echo.
echo.
rem Esegui lo script come amministratore
openfiles >nul 2>&1
if '%errorlevel%' NEQ '0' (
    echo Stai per eseguire lo script con privilegi di Amministratore, dai invio per confermare.
    pause
    powershell -Command "Start-Process '%~f0' -Verb RunAs"
    exit
)
color B0
:: Mostra un popup di benvenuto
powershell -Command "& {Add-Type -AssemblyName PresentationFramework; [System.Windows.MessageBox]::Show('Benvenuto! Stai per utilizzare gli script di Kris / Mister-Pc')}"

echo.
echo.
echo                  Benvenuto! stai per utilizzare degli script di Mister-Pc
echo                  Canale you tube : https://www.youtube.com/@Mister-Pc-Kris 
echo                         Sito web: https://tecnomaniaci.com/
echo.
echo Con questo script potrai scegliere di impostare un punto di riprisino pianificato (punti 1-2-3)
echo         Potrai effettuare un punto di ripristino immediato manualmente (punto 4)
echo.
echo.


:menu
echo Scegli un'opzione:
echo 1. Programmare il Task Scheduler per creare un punto di ripristino ogni giorno alle 12:00
echo 2. Programmare il Task Scheduler per creare un punto di ripristino ogni 5 giorni alle 12:00
echo 3. Programmare il Task Scheduler per creare un punto di ripristino ogni 10 giorni alle 12:00
echo 4. Creare un punto di ripristino manuale ora
echo 5. Esci
set /p choice=Inserisci la tua scelta (1, 2, 3, 4, o 5): 

if "%choice%"=="1" goto schedule_daily
if "%choice%"=="2" goto schedule_5_days
if "%choice%"=="3" goto schedule_10_days
if "%choice%"=="4" goto manual
if "%choice%"=="5" goto exit

:: Ritorna al menu se la scelta non è valida
goto menu

:schedule_daily
:: Cancella eventuali task precedenti con lo stesso nome
schtasks /delete /tn "Punto di Ripristino Automatico Giornaliero" /f
schtasks /delete /tn "Punto di Ripristino Automatico Ogni 5 Giorni" /f
schtasks /delete /tn "Punto di Ripristino Automatico Ogni 10 Giorni" /f

:: Crea lo script PowerShell per creare un punto di ripristino in C:\Program Files
echo Checkpoint-Computer -Description "Punto di ripristino automatico giornaliero" -RestorePointType "MODIFY_SETTINGS" > "C:\Program Files\CreateRestorePoint.ps1"

:: Programma il Task Scheduler per eseguire il comando ogni giorno alle 12:00
schtasks /create /tn "Punto di Ripristino Automatico Giornaliero" /tr "powershell.exe -ExecutionPolicy Bypass -File \"C:\Program Files\CreateRestorePoint.ps1\"" /sc daily /st 12:00 /rl highest /f
echo Task Scheduler programmato per ogni giorno alle 12:00.
goto end

:schedule_5_days
:: Cancella eventuali task precedenti con lo stesso nome
schtasks /delete /tn "Punto di Ripristino Automatico Giornaliero" /f
schtasks /delete /tn "Punto di Ripristino Automatico Ogni 5 Giorni" /f
schtasks /delete /tn "Punto di Ripristino Automatico Ogni 10 Giorni" /f

:: Crea lo script PowerShell per creare un punto di ripristino in C:\Program Files
echo Checkpoint-Computer -Description "Punto di ripristino automatico ogni 5 giorni" -RestorePointType "MODIFY_SETTINGS" > "C:\Program Files\CreateRestorePoint.ps1"

:: Programma il Task Scheduler per eseguire il comando ogni 5 giorni alle 12:00
schtasks /create /tn "Punto di Ripristino Automatico Ogni 5 Giorni" /tr "powershell.exe -ExecutionPolicy Bypass -File \"C:\Program Files\CreateRestorePoint.ps1\"" /sc daily /mo 5 /st 12:00 /rl highest /f
echo Task Scheduler programmato per ogni 5 giorni alle 12:00.
goto end

:schedule_10_days
:: Cancella eventuali task precedenti con lo stesso nome
schtasks /delete /tn "Punto di Ripristino Automatico Giornaliero" /f
schtasks /delete /tn "Punto di Ripristino Automatico Ogni 5 Giorni" /f
schtasks /delete /tn "Punto di Ripristino Automatico Ogni 10 Giorni" /f

:: Crea lo script PowerShell per creare un punto di ripristino in C:\Program Files
echo Checkpoint-Computer -Description "Punto di ripristino automatico ogni 10 giorni" -RestorePointType "MODIFY_SETTINGS" > "C:\Program Files\CreateRestorePoint.ps1"

:: Programma il Task Scheduler per eseguire il comando ogni 10 giorni alle 12:00
schtasks /create /tn "Punto di Ripristino Automatico Ogni 10 Giorni" /tr "powershell.exe -ExecutionPolicy Bypass -File \"C:\Program Files\CreateRestorePoint.ps1\"" /sc daily /mo 10 /st 12:00 /rl highest /f
echo Task Scheduler programmato per ogni 10 giorni alle 12:00.
goto end

:manual
:: Chiedi all'utente di inserire il nome del punto di ripristino
set /p nomeRipristino=Inserisci il nome del punto di ripristino: 
:: Creare un punto di ripristino utilizzando PowerShell
powershell.exe -Command "Checkpoint-Computer -Description '%nomeRipristino%' -RestorePointType 'MODIFY_SETTINGS'"
echo Punto di ripristino creato con successo.
goto end

:exit
echo Uscita.
exit /b

:end
pause
goto menu